import { type AuthProvider, type HttpRequest } from './auth.js';
import { AccessToken, type ExternalJwtCredentials } from './oidc.js';
export declare class OIDCExternalJwtProvider implements AuthProvider {
    oidcAuth: AccessToken;
    externalJwt?: string;
    constructor({ clientId, externalJwt, oidcOrigin, }: Partial<ExternalJwtCredentials> & Omit<ExternalJwtCredentials, 'exchange'>);
    updateClientPublicKey(signingKey: CryptoKeyPair): Promise<void>;
    withCreds(httpReq: HttpRequest): Promise<HttpRequest>;
}
//# sourceMappingURL=oidc-externaljwt-provider.d.ts.map