/**
 *
 * Copyright (c) 2016 SafeBash
 * Cryptography consultant: Andrew Kozlik, Ph.D.
 *
 * @link https://github.com/safebash/opencrypto
 *
 */
interface KeyAgreementOptions {
    bitLength: number;
    hkdfHash: HashAlgorithmIdentifier;
    hkdfInfo: Uint8Array;
    hkdfSalt: Uint8Array | ArrayBuffer;
    keyCipher: string;
    keyLength: number;
    keyUsages: KeyUsage[];
    isExtractable: boolean;
}
/**
 *
 * ECDH Key Agreement
 * - publicKey          {CryptoKey}     default: "undefined"
 * - privateKey         {CryptoKey}     default: "undefined"
 * - options            {Object}        default: { bitLength: 256, hkdfHash: 'SHA-512', hkdfSalt: "new UInt8Array()", hkdfInfo: "new UInt8Array()", keyCipher: 'AES-GCM', keyLength: 256, keyUsages: ['encrypt', 'decrypt', 'wrapKey', 'unwrapKey'], isExtractable: true }
 */
export declare function keyAgreement(privateKey: CryptoKey, publicKey: CryptoKey, options?: Partial<KeyAgreementOptions>): Promise<CryptoKey>;
export {};
//# sourceMappingURL=keyAgreement.d.ts.map