import { type Binary } from '../binary.js';
import { type CryptoService, type DecryptResult, type EncryptResult } from '../crypto/declarations.js';
export declare abstract class SymmetricCipher {
    cryptoService: CryptoService;
    name?: string;
    ivLength?: number;
    keyLength?: number;
    constructor(cryptoService: CryptoService);
    generateInitializationVector(): Promise<string>;
    generateKey(): Promise<string>;
    abstract encrypt(payload: Binary, key: Binary, iv: Binary): Promise<EncryptResult>;
    abstract decrypt(payload: Uint8Array, key: Binary, iv?: Binary): Promise<DecryptResult>;
}
//# sourceMappingURL=symmetric-cipher-base.d.ts.map