import { KeyInfo } from '../models/index.js';
export { ZipReader, readUInt64LE } from './zip-reader.js';
export { ZipWriter } from './zip-writer.js';
export { keySplit, keyMerge } from './keysplit.js';
export { streamToBuffer } from '../client/DecoratedReadableStream.js';
export type SupportedEncoding = 'hex' | 'utf8' | 'utf-8' | 'binary' | 'latin1' | 'base64';
export declare function concatUint8(uint8Arrays: Uint8Array[]): Uint8Array;
export declare function readUInt32LE(uint8Array: Uint8Array, offset: number): number;
export declare function readUInt16LE(uint8Array: Uint8Array, offset: number): number;
export declare function readUInt32BE(arrayBuffer: ArrayBuffer, offset: number): number;
export declare function writeUInt16LE(uint8Array: Uint8Array, value: number, offset: number): void;
export declare function writeUInt32LE(uint8Array: Uint8Array, value: number, offset: number): void;
export declare function copyUint8Arr(source: Uint8Array, target: Uint8Array, targetStart?: number, sourceStart?: number, sourceEnd?: number): number;
export declare function buffToString(source: Uint8Array, encoding?: SupportedEncoding, start?: number, end?: number): string;
export declare function utf8Slice(buf: Uint8Array, start: number, end: number): string;
export declare function base64ToBytes(str: string): Uint8Array;
/**
 *
 * Function generates key, it returned both KeyForEncryption and KeyForManifest.
 *   `KeyForEncryption === KeyForManifest` produces true;
 *
 * @returns {Object}:
 * {
 *   keyForEncryption: Binary;
 *   keyForManifest: Binary;
 * }
 */
export declare function keyMiddleware(): Promise<{
    keyForEncryption: KeyInfo;
    keyForManifest: KeyInfo;
}>;
//# sourceMappingURL=index.d.ts.map