export declare function writeUInt64LE(buffer: Uint8Array, n: number, offset: number): void;
/**
 * Strangely encoded date/time found in FAT* file systems
 */
export type DosDateTime = {
    /**
     * The MS-DOS date. The date is a packed value with the following format.
     *  Bits    Description
     *  0-4     Day of the month (1–31)
     *  5-8     Month (1 = January, 2 = February, and so on)
     *  9-15    Year offset from 1980 (add 1980 to get actual year)
     */
    date: number;
    /**
     * The MS-DOS time. The time is a packed value with the following format.
     * Bits   Description
     * 0-4    Second divided by 2
     * 5-10   Minute (0–59)
     * 11-15  Hour (0–23 on a 24-hour clock)
     */
    time: number;
};
export declare function dateToDosDateTime(jsDate: Date): DosDateTime;
/**
 * Utilities for writing zip file structures.
 */
export declare class ZipWriter {
    zip64: boolean;
    constructor();
    getLocalFileHeader(utf8FileName: string, crc32: number, compressedSize: number, uncompressedSize: number, now?: Date): Uint8Array<ArrayBufferLike>;
    writeDataDescriptor(crc32: number, uncompressedSize: number): Uint8Array;
    writeCentralDirectoryRecord(uncompressedSize: number, utf8FileName: string, relativeOffsetOfLocalHeader: number, crc32: number, externalFileAttributes: number, now?: Date): Uint8Array;
    writeEndOfCentralDirectoryRecord(entriesLength: number, sizeOfCentralDirectory: number, offsetOfStartOfCentralDirectory: number): Uint8Array<ArrayBufferLike>;
}
//# sourceMappingURL=zip-writer.d.ts.map